***Gravity estimation: 01/20/14
*******************************You can include distance, border, language, etc.***********************
clear
use "[the path]"

set more off
set matsize 11000

*tset idpair year, yearly
*iso_o=is the importer id; iso_d=exporter id
encode iso_o, gen(id1)
encode iso_d, gen(id2)

gen id3=id1*100
gen id4=id2*100
egen id = concat(id3 id4)
destring id, replace

*****Variables
*I will assume these names
*y=FDI
*bi=Bilateral Investment Treaty
*fta=Free Trade Agreement
*cc=Common Currency
*ny=NYC Convention
*q=quality
*lgdp=log(gdp_i*gdp_j)

*Adjustment variable 

gen l1=lgdp^2

*Dependent variable

gen yobs=0
replace yobs=y if y>1 
*remember y=FDI

gen yobs1=yobs+1
gen ly=log(yobs1)

*The first step variable

gen delta=1
replace delta=0 if ly==0

***Model fixed parameters

gen ci=0
gen const=0.05
gen deltan=.05

*If you wanna estimate another quantile, you must change here
*Quantile

gen tau=.5

*************************************Pay attention, we get a new step before the First Step.****************************

**Endogenous variable = endo
**Instruments IV1 and IV2

reg endo IV1 IV2
predict varfree, resid

***First Step

*change the variables names
*The dependent variable is delta
*Multilateral variables: Dummies for exporter and importer : 
*we have varfree now!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

xi: logit delta varfree bi fta cc ny q lgdp  l1 i.ido i.idd i.year
predict lfitted,pu0  
gen j0=1
replace j0=0 if lfitted<(1-tau+const)

*the dependent variable is ly 
xi: reg ly varfree bi fta cc ny q lgdp l1 i.year if j0==1, robust
         predict fitreg3

gen alphaols=lm-fitreg3
egen hatalphaols=mean(alphaols), by(ido idd)
egen intercept=mean(hatalphaols)
gen hatalpha=hatalphaols-intercept
gen yco=lm-hatalpha

*If you wanna estimate another quantile, you must change here 
*the dependent variable is yco

xi: qreg yco varfree bi fta cc ny q lgdp i.year l1 if j0==1, quantile(.5)
predict fitqregols

gen jco=1
replace jco=0 if fitqregols+hatalpha<(1-deltan+ci)

*the dependent variable is ly 
xi: reg ly varfree bi fta cc ny q lgdp l1 i.year if jco==1, robust
predict fitreg4


gen alphai=lm-fitreg4
egen hatalphai=mean(alphai), by(ido idd)
egen intercept1=mean(hatalphai)
gen hatalpha2=hatalphai-intercept1
gen ycols=lm-hatalpha2

*If you wanna estimate another quantile, you must change here 
*the dependent variable is ycols
xi: qreg ycols varfree ly bi fta cc ny q lgdp l1 i.year if jco==1,quantile(.5)

